<?php

require_once 'Area.php';

require_once 'data/MySQLBackEndDataModel.php';

//backend db <> area model
class BEAreaModel 
{
    private $m_DataAccess;
    
    public function __construct()
    {
        $this->m_DataAccess = new MySQLBackEndDataModel();
    }
    
    public function __destruct()
    {
        // not doing anything at the moment
    }
            
    //get area by its name (for populating the edit form)
    public function fetchArea($areaID)
    {
        $area = new Area();
        $this->m_DataAccess->connectToDB();
        $areaRecord = $this->m_DataAccess->findArea($areaID);
        $area->setName($areaRecord['name']);
        $area->setAlias($areaRecord['alias']);
        $area->setOrder($areaRecord['order']);
        $area->setDescription($areaRecord['description']);
        return $area;
    }
    
    //get all areas (for the table of areas)
    public function fetchAllAreas()
    {
        $areasArray = array();
        $this->m_DataAccess->connectToDB();
        $this->m_DataAccess->selectAreas();
        while($row = $this->m_DataAccess->fetchAreas())
        {
            $currentArea = new Area();
            $currentArea->setName($row['name']);
            $currentArea->setAlias($row['alias']);
            $currentArea->setOrder($row['order']);
            $currentArea->setDescription($row['description']);
            $currentArea->setCreate_by($row['create_by']);
            $currentArea->setCreate_dt($row['create_dt']);
            $currentArea->setMod_by($row['mod_by']);
            $currentArea->setMod_dt($row['mod_dt']);
            $areasArray[] = $currentArea;
        }
        return $areasArray;
    }
    
    //create new area
    public function insertArea($who,$name,$alias,$order,$description)
    {
        
        $newArea = new Area();
        $newArea->setName($name);
        $newArea->setAlias($alias);
        $newArea->setOrder($order);
        $newArea->setDescription($description);
        
        //save the new area to the DB
        $this->m_DataAccess->connectToDB();
        $this->m_DataAccess->saveNewArea($who,$newArea);
        return;
    }
    
    //update area
    public function editArea($who,$oname,$name,$alias,$order,$description)
    {
        $editArea = new Area();
        
        $editArea->setName($name);
        $editArea->setAlias($alias);
        $editArea->setOrder($order);
        $editArea->setDescription($description);
        
        //save the edited area to the DB
        $this->m_DataAccess->connectToDB();
        $this->m_DataAccess->updateArea($who, $oname, $editArea);
        return;
    }
    
    //delete an area given its name
    public function deleteArea($who,$name)
    {
        //delete the area
        $this->m_DataAccess->connectToDB();
        $this->m_DataAccess->deleteArea($who, $name);
        return;
    }
    
}

?>
