<?php

require_once 'Page.php';

require_once 'data/MySQLBackEndDataModel.php';

//backend db <> page model
class BEPageModel 
{
    private $m_DataAccess;
    
    public function __construct()
    {
        $this->m_DataAccess = new MySQLBackEndDataModel();
    }
    
    public function __destruct()
    {
        // not doing anything at the moment
    }
            
    //get a page given its name (for populating the edit form)
    public function fetchPage($pageID)
    {
        $page = new Page();
        $this->m_DataAccess->connectToDB();
        $pageRecord = $this->m_DataAccess->findPage($pageID);
        $page->setName($pageRecord['name']);
        $page->setAlias($pageRecord['alias']);
        $page->setDescription($pageRecord['description']);
        return $page;
    }
    
    //get all pages (for the table of pages)
    public function fetchAllPages()
    {
        $pagesArray = array();
        $this->m_DataAccess->connectToDB();
        $this->m_DataAccess->selectPages();
        while($row = $this->m_DataAccess->fetchPages())
        {
            $currentPage = new Page();
            $currentPage->setName($row['name']);
            $currentPage->setAlias($row['alias']);
            $currentPage->setDescription($row['description']);
            $currentPage->setCreate_by($row['create_by']);
            $currentPage->setCreate_dt($row['create_dt']);
            $currentPage->setMod_by($row['mod_by']);
            $currentPage->setMod_dt($row['mod_dt']);
            $pagesArray[] = $currentPage;
        }
        return $pagesArray;
    }
    
    //create a new page
    public function insertPage($who,$name,$alias,$description)
    {
        
        $newPage = new Page();
        $newPage->setName($name);
        $newPage->setAlias($alias);
        $newPage->setDescription($description);
        
        //save the new page to the DB
        $this->m_DataAccess->connectToDB();
        $this->m_DataAccess->saveNewPage($who,$newPage);
        return;
    }
    
    //update page
    public function editPage($who,$oname,$name,$alias,$description)
    {
        $editPage = new Page();
        
        $editPage->setName($name);
        $editPage->setAlias($alias);
        $editPage->setDescription($description);
        
        //save the new user to the DB
        $this->m_DataAccess->connectToDB();
        $this->m_DataAccess->updatePage($who, $oname, $editPage);
        return;
    }
    
    //delete a page given its name
    public function deletePage($who,$name)
    {
        //delete the page
        $this->m_DataAccess->connectToDB();
        $this->m_DataAccess->deletePage($who, $name);
        return;
    }
    
}

?>
