<?php

require_once 'Template.php';

require_once 'data/MySQLBackEndDataModel.php';

//backend db <> template model
class BETemplateModel 
{
    private $m_DataAccess;
    
    public function __construct()
    {
        $this->m_DataAccess = new MySQLBackEndDataModel();
    }
    
    public function __destruct()
    {
        // not doing anything at the moment
    }
            
    //get a template given its name (for populating the edit form)
    public function fetchTemplate($templateID)
    {
        $template = new Template();
        $this->m_DataAccess->connectToDB();
        $templateRecord = $this->m_DataAccess->findTemplate($templateID);
        $template->setName($templateRecord['name']);
        $template->setDescription($templateRecord['description']);
        $template->setIsActive($templateRecord['isActive']);
        $template->setDirectives($templateRecord['directives']);
        return $template;
    }
    
    //get all templates (for the table of templates)
    public function fetchAllTemplates()
    {
        $templatesArray = array();
        $this->m_DataAccess->connectToDB();
        $this->m_DataAccess->selectTemplates();
        while($row = $this->m_DataAccess->fetchTemplates())
        {
            $currentTemplate = new Template();
            $currentTemplate->setName($row['name']);
            $currentTemplate->setDescription($row['description']);
            $currentTemplate->setIsActive($row['isActive']);
            $currentTemplate->setDirectives($row['directives']);
            $currentTemplate->setCreate_by($row['create_by']);
            $currentTemplate->setCreate_dt($row['create_dt']);
            $currentTemplate->setMod_by($row['mod_by']);
            $currentTemplate->setMod_dt($row['mod_dt']);
            $templatesArray[] = $currentTemplate;
        }
        return $templatesArray;
    }
    
    //create new template
    public function insertTemplate($who,$name,$description,$isActive,$directives)
    {
        
        $newTemplate = new Template();
        $newTemplate->setName($name);
        $newTemplate->setDescription($description);
        $newTemplate->setIsActive($isActive);
        $newTemplate->setDirectives($directives);
        
        //save the new template to the DB
        $this->m_DataAccess->connectToDB();
        $this->m_DataAccess->saveNewTemplate($who,$newTemplate);
        return;
    }
    
    //update template
    public function editTemplate($who,$oname,$name,$description,$isActive,$directives)
    {
        $editTemplate = new Template();
        
        $editTemplate->setName($name);
        $editTemplate->setDescription($description);
        $editTemplate->setIsActive($isActive);
        $editTemplate->setDirectives($directives);
        
        //save the edited template to the DB
        $this->m_DataAccess->connectToDB();
        $this->m_DataAccess->updateTemplate($who, $oname, $editTemplate);
        return;
    }
    
    //delete template
    public function deleteTemplate($who,$name)
    {
        //delete the template
        $this->m_DataAccess->connectToDB();
        $this->m_DataAccess->deleteTemplate($who, $name);
        return;
    }
    
}

?>
